/// <reference path="src/typings/applicationinsights-js/applicationinsights-js.d.ts" />
/// <reference path="src/typings/angularjs/angularjs.d.ts" />
declare module AngularJs.AppInsightJsV2 {
    class ApplicationInsightsConfig implements Microsoft.ApplicationInsights.IConfig {
        applicationName?: string;
        instrumentationKey?: string;
        endpointUrl?: string;
        emitLineDelimitedJson?: boolean;
        accountId?: string;
        sessionRenewalMs?: number;
        sessionExpirationMs?: number;
        maxBatchSizeInBytes?: number;
        maxBatchInterval?: number;
        enableDebug?: boolean;
        disableExceptionTracking?: boolean;
        disableTelemetry?: boolean;
        verboseLogging?: boolean;
        diagnosticLogInterval?: number;
        samplingPercentage?: number;
        autoTrackPageVisitTime?: boolean;
        disableAjaxTracking?: boolean;
        overridePageViewDuration?: boolean;
        maxAjaxCallsPerView?: number;
        disableDataLossAnalysis?: boolean;
        disableCorrelationHeaders?: boolean;
        correlationHeaderExcludedDomains?: string[];
        disableFlushOnBeforeUnload?: boolean;
        enableSessionStorageBuffer?: boolean;
        isCookieUseDisabled?: boolean;
        cookieDomain?: string;
        isRetryDisabled?: boolean;
        url?: string;
        isStorageUseDisabled?: boolean;
        isBeaconApiDisabled?: boolean;
        sdkExtension?: string;
        isBrowserLinkTrackingEnabled?: boolean;
        appId?: string;
        enableCorsCorrelation?: boolean;
        autoStateChangeTracking?: boolean;
        autoLogTracking?: boolean;
    }
}
declare module AngularJs.AppInsightJsV2 {
    class Utils {
        static noop: (...args: any[]) => void;
        static isNullOrUndefined(input: any): boolean;
        static newGuid(): string;
    }
}
declare module AngularJs.AppInsightJsV2 {
    class ExceptionInterceptor {
        private _origExceptionHandler;
        private _interceptFunction;
        static errorOnHttpCall: boolean;
        setInterceptFunction(func: any): void;
        getPrivateExceptionHanlder(): any;
        constructor($provide: any);
    }
}
declare module AngularJs.AppInsightJsV2 {
    class LogInterceptor {
        private _debugFn;
        private _infoFn;
        private _warnFn;
        private _logFn;
        static interceptFuntion: any;
        private _noop;
        constructor($provide: any);
        setInterceptFunction(func: (message: any, level: any, properties: any) => void): void;
        getPrivateLoggingObject(): {
            debug: any;
            info: any;
            warn: any;
            error: any;
            log: any;
        };
        delegator(originalFn: any, level: any): () => void;
    }
}
declare module AngularJs.AppInsightJsV2 {
    class ApplicationInsightsService implements Microsoft.ApplicationInsights.IAppInsights {
        config: any;
        constructor(_config?: any, logInterceptor?: LogInterceptor, exceptionInterceptor?: ExceptionInterceptor);
        trackEvent(event: Microsoft.ApplicationInsights.IEventTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        startTrackEvent(name: string): any;
        stopTrackEvent(name: string, properties?: {
            [p: string]: string;
        }, measurements?: {
            [p: string]: number;
        }): any;
        trackPageView(pageView: Microsoft.ApplicationInsights.IPageViewTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        startTrackPage(name?: string): void;
        stopTrackPage(name?: string, url?: string, customProperties?: Object): void;
        trackMetric(metric: Microsoft.ApplicationInsights.IMetricTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        trackException(exception: Microsoft.ApplicationInsights.IExceptionTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        trackTrace(trace: Microsoft.ApplicationInsights.ITraceTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        flush(): void;
        setAuthenticatedUserContext(authenticatedUserId: string, accountId?: string, storeInCookie?: boolean): void;
        clearAuthenticatedUserContext(): void;
        _onerror(exception: Microsoft.ApplicationInsights.IAutoExceptionTelemetry): void;
        trackPageViewPerformance(pageViewPerformance: Microsoft.ApplicationInsights.IPageViewPerformanceTelemetry, customProperties?: {
            [key: string]: any;
        }): void;
        addTelemetryInitializer(telemetryInitializer: (item: Microsoft.ApplicationInsights.ITelemetryItem) => boolean | void): void;
        init(): void;
    }
}
declare module AngularJs.AppInsightJsV2 {
    class ApplicationInsightsProvider implements angular.IServiceProvider {
        private _options;
        configure(options: ApplicationInsightsConfig): void;
        $get: () => ApplicationInsightsService;
    }
}

function downloadAndSetup(config){var sdkInstance="appInsightsSDK";window[sdkInstance]="appInsights";var aiName=window[sdkInstance],aisdk=window[aiName]||function(e){function n(e){i[e]=function(){var n=arguments;i.queue.push(function(){i[e].apply(i,n);})}}var i={config:e};i.initialize=!0;var a=document,t=window;setTimeout(function(){var n=a.createElement("script");n.src=e.url||"https://az416426.vo.msecnd.net/next/ai.2.min.js",a.getElementsByTagName("script")[0].parentNode.appendChild(n)});try{i.cookie=a.cookie}catch(e){}i.queue=[],i.version=2;for(var r=["Event","PageView","Exception","Trace","DependencyData","Metric","PageViewPerformance"];r.length;)n("track"+r.pop());n("startTrackPage"),n("stopTrackPage"),n("addTelemetryInitializer");var o="Track"+r[0];if(n("start"+o),n("stop"+o),!(!0===e.disableExceptionTracking||e.extensionConfig&&e.extensionConfig.ApplicationInsightsAnalytics&&!0===e.extensionConfig.ApplicationInsightsAnalytics.disableExceptionTracking)){n("_"+(r="onerror"));var s=t[r];t[r]=function(e,n,a,t,o){var c=s&&s(e,n,a,t,o);return!0!==c&&i["_"+r]({message:e,url:n,lineNumber:a,columnNumber:t,error:o}),c},e.autoExceptionInstrumented=!0}return i}(config);window[aiName]=aisdk;}